extends Node2D

@onready var path : Curve2D = Curve2D.new()
@onready var end_pts : Array[Vector2] = [Vector2(210, -1), # Fails to build decomposition polygons
										Vector2(200, 0), # Builds a single decomp polygon - OK
										Vector2(210,1), # Fails to build decomp polygons
										Vector2(200, 200)] # Builds with many decomp polygons
var idx : int = 0

func _physics_process(_delta):
	path.clear_points()
	path.add_point(Vector2(0,0), Vector2(0, 0), Vector2(10, 0))
	path.add_point(end_pts[idx], Vector2(-10, 0), Vector2(0, 0))
	var polygons = Geometry2D.offset_polyline(path.get_baked_points(), 
											  5,
											  Geometry2D.JOIN_SQUARE,
											  Geometry2D.END_SQUARE)
	Geometry2D.decompose_polygon_in_convex(polygons[0]) # generates the error directly
	$CollisionPolygon2D.set_polygon(polygons[0]) # generates the same error indirectly

func _draw() -> void:
	draw_polyline(path.get_baked_points(), Color(1,0,0), 1)

func _input(event):
	if event is InputEventMouseButton and event.is_pressed():
		idx = (idx + 1)%end_pts.size()
	queue_redraw()
